
package net.mcreator.reverseddimensions.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;
import net.minecraftforge.fluids.FluidAttributes;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.reverseddimensions.init.ReversedDimensionsModItems;
import net.mcreator.reverseddimensions.init.ReversedDimensionsModFluids;
import net.mcreator.reverseddimensions.init.ReversedDimensionsModBlocks;

public abstract class OilFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(ReversedDimensionsModFluids.OIL,
			ReversedDimensionsModFluids.FLOWING_OIL,
			FluidAttributes.builder(new ResourceLocation("reversed_dimensions:blocks/oil"), new ResourceLocation("reversed_dimensions:blocks/oil"))

	).explosionResistance(100f).canMultiply()

			.bucket(ReversedDimensionsModItems.OIL_BUCKET).block(() -> (LiquidBlock) ReversedDimensionsModBlocks.OIL.get());

	private OilFluid() {
		super(PROPERTIES);
	}

	public static class Source extends OilFluid {
		public Source() {
			super();
		}

		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends OilFluid {
		public Flowing() {
			super();
		}

		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
