
package net.mcreator.reverseddimensions.item;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.reverseddimensions.init.ReversedDimensionsModTabs;
import net.mcreator.reverseddimensions.init.ReversedDimensionsModItems;

public abstract class GrimArmorItem extends ArmorItem {
	public GrimArmorItem(EquipmentSlot slot, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForSlot(EquipmentSlot slot) {
				return new int[]{13, 15, 16, 11}[slot.getIndex()] * 15;
			}

			@Override
			public int getDefenseForSlot(EquipmentSlot slot) {
				return new int[]{3, 6, 7, 4}[slot.getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 14;
			}

			@Override
			public SoundEvent getEquipSound() {
				return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(ReversedDimensionsModItems.GRIM_INGOT.get()));
			}

			@Override
			public String getName() {
				return "grim_armor";
			}

			@Override
			public float getToughness() {
				return 2.5f;
			}

			@Override
			public float getKnockbackResistance() {
				return 0f;
			}
		}, slot, properties);
	}

	public static class Helmet extends GrimArmorItem {
		public Helmet() {
			super(EquipmentSlot.HEAD, new Item.Properties().tab(ReversedDimensionsModTabs.TAB_GRIM_ISLANDSS));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "reversed_dimensions:textures/models/armor/grim_layer_1.png";
		}
	}

	public static class Chestplate extends GrimArmorItem {
		public Chestplate() {
			super(EquipmentSlot.CHEST, new Item.Properties().tab(ReversedDimensionsModTabs.TAB_GRIM_ISLANDSS));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "reversed_dimensions:textures/models/armor/grim_layer_1.png";
		}
	}

	public static class Leggings extends GrimArmorItem {
		public Leggings() {
			super(EquipmentSlot.LEGS, new Item.Properties().tab(ReversedDimensionsModTabs.TAB_GRIM_ISLANDSS));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "reversed_dimensions:textures/models/armor/grim_layer_2.png";
		}
	}

	public static class Boots extends GrimArmorItem {
		public Boots() {
			super(EquipmentSlot.FEET, new Item.Properties().tab(ReversedDimensionsModTabs.TAB_GRIM_ISLANDSS));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "reversed_dimensions:textures/models/armor/grim_layer_1.png";
		}
	}
}
